from pyplasm import *



def House2D():
    wall = MKPOL([[[0,0],[8,0],[0,6],[8,6],[4,8]],[range(1,6)],[[1]]])
    door = CUBOID([2,4])
    window = CUBOID([1,2])
    return DIFFERENCE([wall, T(1)(2)(door), T([1,2])([5,2])(window)])

House3D = PROD([ House2D(), Q(5) ])

#///Generic transformation//////////////////////////////

m = MAT([[1,0,0],[0,0.2,0.5],[0,1.1,.3]])

out = STRUCT([m(CUBOID([1,1])), SKELETON(1)(CUBOID([1,1]))])


VIEW(out)

VIEW(m(T([1,2])([-10,-10])(SKELETON(1)(PROD([QUOTE([1]*20),QUOTE([1]*20)])))))



#///Shearing//////////////////////////////


def Hx(a): return MAT([[1,0,0],[0,1,a],[0,0,1]])


out = STRUCT([Hx(1./2)(House2D()), SKELETON(1)(House2D())])

out = STRUCT([Hx(-1./2)(House2D()), SKELETON(1)(House2D())])

VIEW(out)


#///Rotation//////////////////////////////


R([1,2])(PI/6)(House2D())

out = STRUCT([R([1,2])(-PI/6)(House2D()), SKELETON(1)(House2D())])

VIEW(out)




out = STRUCT([R([1,3])(PI/6)(House3D), SKELETON(1)(House3D)])

VIEW(out)


#///Reflection//////////////////////////////

out = STRUCT([S(1)(-1)(House2D()), SKELETON(1)(House2D())])

out = STRUCT([S(2)(-1)(House2D()), SKELETON(1)(House2D())])

VIEW(out)
